function [LL, A, PP] = lupd(A, b, full=0)
# U overwrites A

[m,n] = size(A);
mn = min(m,n);

# L enable
if (full > 0 ) 
  L = rand(m,n);
  P = eye(m,m);
  lc = 0;
  if(mn < m)
    full=0;
  endif
endif

# acc enable 
#acc = A;


for d = 1:b:mn
  bend = d+b-1;

# factorize the diagonal block
  #printf("diagonal\n");
  block = A(d:bend,d:bend);
  [ l, u, p] = lu(block);

  if (full > 0) 
    pem = eye(m,m);
    pem(d:bend,d:bend)=p;
    for li = 1:lc
      L(:,:,li) = pem * L(:,:,li) * inv(pem);
    end

    lc = lc + 1;
    tL = eye(m,n);
    tL(d:bend, d:bend) = l;
    L(:, :, lc) = tL;

    P(:, :, lc) = pem;
  endif

# acc
#  accL = inv(tL);
#  acc = P(:, :, lc) * acc;
#  acc = accL * acc;

  A(d:bend,d:bend) = u;

# apply the pivoting to the blocks on the right
  linv = inv(l);
  for j = d+b:b:n
      rbend = j + b - 1;
      block = A(d:bend,j:rbend);
      block = p * block;
      block = linv * block; 
      A(d:bend,j:rbend) = block;
  end

# combine the factorization with the matrix below row d
  for i = d+b:b:m
    #printf("lower\n");
    rend = i+b-1;
    block = A(i:rend, d:bend);

    c = vertcat(u,block);
    [ ll, uu, pp ] = lu(c);

    # incorporate the new u into A
    A(d:bend, d:bend) = uu;
    A(i:rend, d:bend) = zeros(b,b);

    llt = ll(1:b, 1:b );
    llb = ll(b+1:2*b , 1:b);

    if (full > 0)
      pem = eye(m,m);
      pp11 = pp(1:b, 1:b);
      pp12 = pp(1:b, b+1:2*b);
      pp21 = pp(b+1:2*b, 1:b);
      pp22 = pp(b+1:2*b, b+1:2*b);
      pem(d:bend, d:bend) = pp11;
      pem(d:bend, i:rend) = pp12;
      pem(i:rend, d:bend) = pp21;
      pem(i:rend, i:rend) = pp22;
      # apply the pivots to previous L
      for li = 1:lc
	L(:,:,li) = pem * L(:,:,li) * inv(pem);
      end

      lc = lc + 1;

      tL = eye(m,n);
      tL(d:bend,d:bend) = llt;
      tL(i:rend,d:bend) = llb;
      L(:,:,lc) = tL;

      P(:, :, lc) = pem;
    endif

# acc enable
#    accL = inv(tL);
#    acc = P(:, :, lc) * acc;
#    acc = accL * acc;

    for j = d+b:b:n
      cend = j+b-1;
      At = A(d:bend, j:cend);
      Ab = A(i:rend, j:cend);

      Aj = vertcat(At, Ab);
      Aj = pp * Aj;

      At = Aj(1:b, :);
      Ab = Aj(b+1:2*b, :);

      At = inv(llt) * At;
      A(d:bend, j:cend) = At;

      Ab = Ab - llb * At;
      A(i:rend, j:cend) = Ab;
    end

# acc enable
#    nrm = norm ( abs(A) - abs(acc) , 1);

    # have to reload the upper block in U (A)
    u = A(d:bend,d:bend); 

  end

end

LL = eye(m,n);
PP = eye(m,m);

if(full > 0)
  for li = 1:lc
    LL = LL * L(:,:,li);
  end

  for li = lc:-1:1
    PP = PP * P(:,:,li);
  end
endif
