#!/bin/bash

if ! hash octave 2>/dev/null; then
	echo "error: could not find Octave" >&2
	exit 1
fi

mmax=${1}
it=${2}

trap 'rm -f lupdcheck_* ; rm -f err_* ; exit 1' SIGINT
errf=$( mktemp "err_XXXXXX" )
errc=0

for bc in $( seq 4 128 ); do
	let brmax=${bc}\*16
	for br in $( seq ${bc} ${bc} ${brmax} ); do
		for m in $( seq $br $br $mmax ); do
			let n=$m+$bc
			for i in $( seq 1 ${it} ); do
				../bin/lupd ${m} ${n} ${br} ${bc} ${bc} 1 2 &> /dev/null
				#echo "./luca ${m} ${n} ${br} ${bc} ${bc} 1 2"
				err=$( octave --silent lupdcheck_* )
				ok=$( echo "$err > 0.0001" | bc )
				if [ $ok -eq 1 ]; then
					echo "error: $m x $m($n) $br x $bc -> $err" >> ${errf}
					let errc=${errc}+1
				fi
				printf "\r%8ix%8i %8ix%8i  %.12f" $m $n $br $bc $err
				rm -f lupdcheck_*
			done
		done
	done
done

if [ $errc -ne 0 ]; then
	echo "wrote error file ${errf}"
else
	rm ${errf}
fi
