#!/bin/bash

if ! hash octave 2>/dev/null; then
	echo "error: could not find Octave" >&2
	exit 1
fi

mmax=${1}
it=${2}


for bc in $( seq 4 64 ); do
	let brmax=${bc}\*16
	for br in $( seq ${bc} ${bc} ${brmax} ); do
			for m in $( seq $br $br $mmax ); do
				for n in $( seq $bc $bc $m ); do
					#echo -n "$m x $n  $br x $bc "

					for i in $( seq 1 ${it} ); do
						../bin/lupd ${m} ${n} ${br} ${bc} ${bc} 1 2 &> /dev/null
						#echo "./luca ${m} ${n} ${br} ${bc} ${bc} 1 2"
						err=$( octave --silent lupdcheck_* )
						ok=$( echo "$err > 0.00001" | bc )
						if [ $ok -eq 1 ]; then
							echo
							echo "error: $m x $n $br x $bc -> $err" >&2 
							exit 1
						fi
						printf "\r%i x %i %i x %i %f" $m $n $br $bc $err 
						rm -f lupdcheck_*
					done
				done
		done
	done
done
