#!/bin/bash

if ! hash octave 2>/dev/null; then
	echo "error: could not find Octave" >&2
	exit 1
fi

mmax=${1}
it=${2}

trap 'rm -f lupdhcheck_* ; exit 1' SIGINT
errf=$( mktemp "err_XXXXXX" )
errc=0

for b in $( seq 4 128 ); do
	for hr in $( seq 1 16 ); do
		let mstep=$b*$hr
		for m in $( seq $mstep $mstep $mmax ); do
			for hc in $( seq 1 ${hr} ); do
				let nstep=$b*$hc
				for n in $( seq $nstep $nstep $m ); do
					for i in $( seq 1 ${it} ); do
						../bin/lupdh ${m} ${n} ${b} ${hr} ${hc} ${b} 1 2 &> /dev/null
						err=$( octave --silent lupdhcheck_* )
						ok=$( echo "$err > 0.0001" | bc )
						if [ $ok -eq 1 ]; then
							echo "error: $m x $n    $b x $hr x $b x $hc -> $err" >> ${errf}
							let errc=${errc}+1
						fi
						printf "\r%8ix%8i    %4ix%4ix%4ix%4i        %.12f" $m $n $b $hr $b $hc $err
						rm -f lupdhcheck_*
					done
				done
			done
		done
	done
done

if [ $errc -ne 0 ]; then
	echo "wrote error file ${errf}"
else
	rm ${errf}
fi
