#if USE_LUPD || USE_LUPDLL


#include "lu_config.h"
#include "lupd_utils.h"
#include <stdio.h>


extern int m;
extern int n;
extern int br;
extern int bc;
extern int t;
extern int reps;
extern int check;
extern int diagl;
extern int mt;
extern int nt;
extern int h;


int lu_config(int argc, char *argv[]) { 
	if (argc < 5 ) {
		fprintf(stderr, "use: %s m n br bc [t] [reps] [check]\n",argv[0]);
		return 1;
	}

  	m = atoi(argv[1]);
  	n = atoi(argv[2]);
  	br = atoi(argv[3]);
  	bc = atoi(argv[4]);
	if (br % bc != 0) {
      		fprintf(stderr, "bc and br should be multiples of each other.\n");
      		return 1;
    	}
#if USE_LUPDLL
	if (br != bc) {
      		fprintf(stderr, "br and bc must be equal.\n");
      		return 1;
    	}
	
#endif
	t = bc;
	reps = 1;
	check = 0;
	if (argc > 5) {
  		t = atoi(argv[5]);
		if (argc > 6) {
  			reps = atoi(argv[6]);
			if (argc > 7) {
  				check = atoi(argv[7]);
				if ( check > 0 ) {
					printf("warning: enabling error check\n");
				}
			}
		}
	}

	nt = (n+bc-1) / bc;
	mt = (m+br-1) / br;

	diagl=(min(m,n)+bc-1)/bc;
	h = 1;

	return 0;
}


#endif // LUPD 
