#ifndef __LUPD_KERNELS_H__
#define __LUPD_KERNELS_H__


#pragma omp task inout( A[0;m * n] ) priority(3)
void dgetrf_task( int m, int n, int skip, double *A, int ldim, int *IPIV );


#pragma omp task input( L[0;m * n] ) \
                 inout( C[0;m * n] ) priority(1)
void dtrsm_dgemm_task( int m, int n, int skip, double *L, int ldim, int * IPIV, double *C );


#pragma omp task inout( buff_U[0;m*n], buff_D[0;m*m]) \
                 output( buff_S[0;t*n]) priority(2)
void dgetrf_split_task( int t, int m, int n, int split, double * buff_U, int ldim, double * buff_D, double * buff_S, int * buff_ipiv );


#pragma omp task input( buff_S[0;t*n]) \
                 inout( buff_F[0;m*n], buff_G[0;m*n])
void dtrsm_dgemm_split_task( int t, int m, int n, int split, double * buff_D, int ldim, double * buff_S, 
        int * buff_P, double * buff_F, double * buff_G);


#endif // __LUPD_KERNELS_H__
