#ifndef __LUCA_TIME_H__
#define __LUCA_TIME_H__


#include <sys/times.h>


static inline __attribute__((always_inline)) double mytime() {
	struct tms t;

	clock_t ct = times( &t );
	if ( ct == (clock_t) -1 ) {
		return 0.0;
	} else {
		return ( ( (double) ct ) / ( (double) sysconf( _SC_CLK_TCK ) ) );
  }
}


#endif // __LUCA_TIME_H__
