#ifndef __LUPDH_KERNELS_H__
#define __LUPDH_KERNELS_H__


#pragma omp task inout( A[0;mb*b*nb*b] ) priority(3)
void dgetrf_htask( int rskip, int cskip, int mb, int nb, int b, int t, double *A, int *P, double *S);


#pragma omp task input( A[0;mb*b*nb*b] ) \
                 inout( C[0;mb*b*nb*b] ) priority(1)
void dtrsm_dgemm_htask( int rskip, int cskip, int mb, int nb, int b, int t, double *A, int *P, double *S, double *C );


#pragma omp task inout( A[0;mb*b*nb*b], C[0;mb*b*nb*b]) \
                 output( S[0;t*b*mb*nb]) priority(2)
void dgetrf_split_htask( int rskip, int cskip, int mb, int nb, int b, int t, double *A, double *C, int *P, double *S); 


#pragma omp task input( S[0;t*b*mb*nb]) \
                 inout( F[0;mb*b*nb*b], G[0;mb*b*nb*b])
void dtrsm_dgemm_split_htask( int rskip, int cskip, int mb, int nb, int b, int t, double *S, double *D, int *P, double *F, double *G);


#pragma omp task input( A[0;m*n] )  priority(3)
void dgetrf_fac_task(int m, int n, double *A, int ldim, int *P);


#endif // __LUPDH_KERNELS_H__
