#include "lupdh_kernels.h"
#include "lupd_kernels.h"
#include "lupd_utils.h"

#include <stdio.h>



#define Ab(i,j) ( &A[ cbs * j + i * b ] )
#define Pb(i,j) ( &P[ sbr * j + i * b ] )
#define Sb(i,j) ( &S[ ldimS * j + i * bt ] )
#define Db(i,j) ( &D[ cbs * j + i * b ] )
#define Fb(i,j) ( &F[ cbs * j + i * b ] )
#define Gb(i,j) ( &G[ cbs * j + i * b ] )


void dtrsm_dgemm_split_htask( int rskip, int cskip, int mb, int nb, int b, int t, double *S, double *D, int *P, double *F, double *G) {
	int diagl = min(mb-rskip,nb-cskip);
	// super block dimensions
	int sbr = mb*b;
	// column block size
	int cbs = sbr * b;
	int ldimS = sbr * t;
	int bt = b * t;

	//printf("\nh: dtrsm_dgemm_split: %i skip %i %i\n",rskip, cskip, diagl);

	//double *Ft = &F[ sbr*0 + 0 ];
	//print_block_cm( stdout, "F", 4, 4, sbr, Ft);


#if 1
	if ( diagl > 0) {
		double *Di = Db(0,cskip);
		int *Pi = Pb(0,cskip);
		double *Si = Sb(0,cskip);

		double *Fj = Fb(rskip,0);
		double *Gj = Gb(0,0);
		dtrsm_dgemm_split( t, b, b, 0, Di, sbr, Si, Pi, Fj, Gj);

		int j;
		for ( j=1; j<nb ; j++ ) {
			double *Fj = Fb(rskip,j);
			double *Gj = Gb(0,j);

			dtrsm_dgemm_split_task( t, b, b, 0, Di, sbr, Si, Pi, Fj, Gj);
		}

		int i;
		for ( i=1; i<mb; i++) {
			double *Di = Db(i,cskip);
			int *Pi = Pb(i,cskip);
			double *Si = Sb(i,cskip);

			int j;
			for ( j=0; j<nb ; j++ ) {
				double *Fj = Fb(rskip,j);
				double *Gj = Gb(i,j);

				dtrsm_dgemm_split_task( t, b, b, 0, Di, sbr, Si, Pi, Fj, Gj);
			}
		}
	}
#endif


	int k;
	for ( k=1; k<diagl ; k++ ) {
		int r = rskip+k;
		int c = cskip+k;

		int i;
		for ( i=0; i<mb; i++) {
			double *Di = Db(i,c);
			int *Pi = Pb(i,c);
			double *Si = Sb(i,c);

			int j;
			for ( j=0; j<nb ; j++ ) {
				double *Fj = Fb(r,j);
				double *Gj = Gb(i,j);

				dtrsm_dgemm_split_task( t, b, b, 0, Di, sbr, Si, Pi, Fj, Gj);
			}
		}
	}
}


#undef Ab
#undef Pb
#undef Sb
#undef Db
#undef Fb
#undef Gb
