#include <stdio.h>
#include "lupd_kernels.h"


// Compute LUpiv of dense matrix A and returns pivots in ipiv vector.
//   Arguments:
//     nb_alg  in                    Block size to be used in the factorization.
//     A       in/out  m_A x n_A     Matrix to be factorized.
//				      Defined by ( buff_A, ldim_A ).
//     ipiv    out     min(m_A,n_A)  Vector with pivots.
//				      Defined by ( buff_ipiv ).
void dgetrf_task( int m, int n, int skip, double *A, int ldim, int *IPIV ) {
	A += skip;
	int mA = m - skip;

	
	// Call to LAPACK routine DGETRF modified to use required blocksize. 
	//dgetrfnbf_( &nb_alg, &mA, &nA, A, & ldimA, IPIV, &info );
	int info;
	dgetrf_( &mA, &n, A, &ldim, IPIV, &info );
	if( info < 0 ) {
		printf( "dgetrf: error (%i)\n", info );
	}
}
