#include "lupdll_main.h"
#include "lupd_kernels.h"

#include <stdio.h>
#include <sys/time.h>


unsigned long lupdll_main(int diagl, int t, int br, int bc, int mt, int nt, int ldim, double **Ah, int **Ph, double **Sh) {
	struct timeval start;
	gettimeofday( &start, NULL );

	printf("diagl %i\n", diagl);

	int k;
	for( k = 0; k < diagl; k++ ) {
		printf("it %i\n",k);

		// process the k-th column
		int i;
		for ( i=0; i<k; i++ ) {

			// process element (i,k)
			int j;
			for ( j =0; j<i; j++ ) {
				dtrsm_dgemm_split_task( t, br, bc, 0, Ah[ mt*j+i], ldim, Sh[ mt*j+i ], Ph[ mt*j+i ], Ah[ mt*k+j ], Ah[ mt*k+i ]);
				printf("m: %i dtrsm_dgemm_split (%i,%i)\n", k, k, i);
			}
			dtrsm_dgemm_task( br, bc, 0, Ah[ mt*i+i ], ldim, Ph[ mt*i+i ], Ah[ mt*k+i ]);
			printf("m: %i dtrsm_dgemm (%i,%i)\n", k, i, k);
		}

		int j;
		for ( j=0; j<k; j++ ) {
			// process element (i,k)
			int i;
			for ( i =0; i<j; i++ ) {
				dtrsm_dgemm_split_task( t, br, bc, 0, Ah[ mt*i+k], ldim, Sh[ mt*i+k ], Ph[ mt*i+k ], Ah[ mt*j+i ], Ah[ mt*j+k ]);
				printf("m: %i dtrsm_dgemm_split (%i,%i)\n", k, k, i);
			}
			dgetrf_split_task( t, br, bc, 0, Ah[ mt*j+j ], ldim, Ah[ mt*j+k ], Sh[ mt*j+k ], Ph[ mt*j+k ] );
			printf("m: %i dgetrf_split (%i,%i) - > (%i,%i)\n", k, j, j, k, j);
		}


		// Factorize block on the diagonal block
		int l;
		for ( l=0; l<k; l++ ) {
			printf("m: %i dtrsm_dgemm_split (%i,%i) & (%i,%i) - > (%i,%i)\n", k, k, l, l, k, k, k);
			dtrsm_dgemm_split_task( t, br, bc, 0, Ah[ mt*l+k ], ldim, Sh[ mt*l+k ], Ph[ mt*l+k ], Ah[ mt*k+l ], Ah[ mt*k+k ]);
		}

		printf("m: %i dgetrf (%i,%i)\n", k, k, k);
		dgetrf_task( br, bc, 0, Ah[ mt*k+k ], ldim, Ph[ mt*k+k ] );
		//printf("dgetrf (%i,%i) %i\n",row,k,rskip);

	}

#if 1
	// i assume the matrix has at least as many rows as it has columns
	int i;
	for ( i=diagl; i<mt; i++ ) {
		int j;
		for ( j=0; j<nt; j++ ) {
			int l;
			for ( l=0; l<j; l++ ) {
				dtrsm_dgemm_split_task( t, br, bc, 0, Ah[ mt*l+i ], ldim, Sh[ mt*l+i ], Ph[ mt*l+i ], Ah[ mt*j+l ], Ah[ mt*j+i ]);
			}
			dgetrf_split_task( t, br, bc, 0, Ah[ mt*j+j ], ldim, Ah[ mt*j+i ], Sh[ mt*j+i ], Ph[ mt*j+i ] );
		}
	}
#endif

#pragma omp taskwait

	struct timeval stop;
	gettimeofday(&stop,NULL);

	unsigned long interm = stop.tv_usec - start.tv_usec;
	interm += (stop.tv_sec - start.tv_sec ) * 1000000;

	return interm;
}
